var file_index = -1;
var viewingArtifact = "${fromViewAction}";
var attachedFilesFormData = new Array();
var removedFileIndices = new Array();
var prohibitedFileTypes = new Array();
var prohibitedAlertText;
var fileNames = new Array();

var $j = jQuery.noConflict();
  $j(document).ready(function() {
  'use strict'

   prohibitedAlertText = document.getElementById('prohibitedFileTypes');
   prohibitedFileTypes = prohibitedAlertText.value.split(",");

    function triggerCallback(e, callback) {
      if(!callback || typeof callback !== 'function') {
        return;
      }
      var files;
      if(e.originalEvent.dataTransfer) {
        files = e.originalEvent.dataTransfer.files;
      } else if(e.target) {
        files = e.target.files;
      }
      callback.call(null, files);
    }

    function makeDroppable(callback) {
      var input = document.createElement('input');
      var ele = document.getElementById('fileDragDropSection');
      var browseSection = document.getElementById('browseSection');
      var browseFiles = document.getElementById('browseFiles');
      var dropText = document.createTextNode('Drop Files here to Attach');
      input.setAttribute('type', 'file');
      input.setAttribute('multiple', true);
      input.setAttribute('id', 'fileElement');
      input.style.display = 'none';
      ele.appendChild(input);

       $j(document).on('change','#fileElement',{}, function(e) {
            triggerCallback(e, callback);
        });

        $j(document).on('dragover','.contentArea', {}, function(e){
            e.preventDefault();
            e.stopPropagation();
            document.getElementById("drag-drop-overlay").style.display = "block";
        });

        $j(document).on('dragleave','.contentArea', {}, function(e){
            e.preventDefault();
            e.stopPropagation();
            setTimeout(leaveAction,1000);
        });

        $j(document).on('drop','.contentArea', {}, function(e){
          e.preventDefault();
          e.stopPropagation();
          document.getElementById("drag-drop-overlay").style.display = "";
          triggerCallback(e, callback);

        });

        $j(document).on('click','.browseButton', {},function(e){
          input.click();
          input.value= null;
        });
    }

    function removeFile(file_index,fileName) {
    	var fileInfoElement = document.getElementById('fileListSection');
        var fileListElement = document.getElementById('fileInfo-'+file_index);
        fileInfoElement.removeChild(fileListElement);
        removedFileIndices.push(file_index);
        var fileNames_index = $j.inArray(fileName,fileNames);
        if (fileNames_index > -1) {
            fileNames.splice(fileNames_index);
        }
    }
    
    function leaveAction() {
       document.getElementById("drag-drop-overlay").style.display="";
    }

    window.makeDroppable = makeDroppable;
    window.removeFile = removeFile;
    window.leaveAction = leaveAction;
  });


$j(document).ready(function() {
  'use strict'
    makeDroppable(function(files) {
      var fileInfo = document.querySelector('.fileInfoList');
      for(var i = 0; i < files.length; i++) {

        file_index++;
        attachedFilesFormData.push(files[i]);

        //filesize > 25 MB exclude files from uploading
        if((files[i].size/1024/1024) > 25) {
            removedFileIndices.push(file_index);
            alert(EXCEEDED_FILE_LIMIT);
            continue;
        }

        // set filesize notattion for smaller files in KB

        var fileNotation = "MB";
        var fileSize = +(files[i].size/1024/1024).toFixed(2);
        if (fileSize < 1) {
            fileSize = +(files[i].size/1024).toFixed(2);
            fileNotation = "KB";
        }

        // prevent duplicate file attachments and build the file list element

        var fileIndex = $j.inArray(files[i].name, fileNames);
        if (fileIndex > -1) {
            removedFileIndices.push(file_index);
            alert(DUPLICATE_FILE);
            continue;
        }

        //prevent prohibited file types
          var fileExt = files[i].name.slice((files[i].name.lastIndexOf(".") - 1 >>> 0) + 2);
          var fileExtIndex = $j.inArray(fileExt,prohibitedFileTypes);
          if (fileExtIndex > -1) {
              removedFileIndices.push(file_index);
              alert(PROHIBITED_FILE_TYPES + prohibitedAlertText.value);
              continue;
          }

        var file_name=files[i].name;
        fileNames.push(file_name);
        var listElement= '<li class="attachmentData" id="fileInfo-'+file_index+'">'+files[i].name+'&nbsp;<span style="font-size: 12px">('+fileSize+ '&nbsp;'+fileNotation+')</span><a style="padding: 20px 5px;" onclick="removeFile('+file_index+','+'\''+file_name+'\''+')"><i class="fa fa-trash-o" style="color: #3dade0;font-size: 12px;"></i><span class="sr-only">Delete</span></a></li>'
        fileInfo.innerHTML += listElement;
      }
    });
  });


